using namespace std;

class Parser
{
      public:
            
   static bool istZahlzeichen(char c)
   {
        if(
              c=='0' || c=='1' || c=='2' || c=='3' || c=='4' || c=='5' || 
              c=='6' || c=='7' || c=='8' || c=='9' || c=='.' || c=='-'
          )
          return true;
        else
          return false;  
          
   }         
            
   /*
       Es wird beim Einlesen von Text aus Files als Zeilenumbruch
       10 statt 13 10 gespeichert. Dies wird hier korrigiert.
   */      
   static string korrigiereUmbruch(string text)
   {
       vector<char> merker;
       for(int i=0;i<text.size();i++)
       {
               if( (i==0 && text.at(i)==10) || (i>0 && text.at(i)==10 && text.at(i-1)!=13) )
               {
                   merker.push_back(13);
                   merker.push_back(10);
               }
               else
               {
                   merker.push_back(text.at(i));
               }
       }
       char* neutext = new char[merker.size()+1];
       for(int i=0;i<merker.size();i++)
       {
               neutext[i] = merker.at(i);
       }
       neutext[merker.size()] = '\0';
       return string(neutext);
   }      


        static string holeASCIIcode(string text)
        {
             stringstream str;   
             string zahl;
             int z;
             string neutext = "";
             
             for(int i=0;i<text.size();i++)
             {
                 z = (int)(text.at(i));
                 str<<z;
                 str>>zahl;
                 neutext.append(zahl);
                 neutext.append(" ");
                 if(i>0 && i%10==0)                  
                     neutext.append("\n");
                 str.clear();    
             }     
             return neutext;
        }     
             
             
        static vector<int>* findeZeichenpositionen(string text, char zeichen)
        {
            vector<int>* pos = new vector<int>(); 

            for(int i=0;i<text.size();i++)
            {
                if(text.at(i)==zeichen)
                    pos->push_back(i);
            }

            return pos;
        }

        static vector<int>* findeZeichenpositionen(string text,string trennzeichen)
        {
            vector<int>* pos = new vector<int>(); 

            for(int i=0;i<text.size();i++)
            {
              for(int k=0;k<trennzeichen.size();k++)
                if(text.at(i)==trennzeichen.at(k))
                    pos->push_back(i);
            }

            return pos;
        }

        static vector<string>* split(string text,char trenner)
        {
            vector<int>* pos = findeZeichenpositionen(text,trenner);

//            for(int i=0;i<pos->size();i++)
//                cout<<(pos->at(i))<<endl;


         

            vector<string>* splittext = new vector<string>();

            int start = 0;
            int ende  = 0;
            for(int i=0;i<(pos->size())+1;i++)
            {
                if(i<pos->size())
                    ende = pos->at(i);
                else
                    ende = text.size();

                if( start < ende  )
                {
                     splittext->push_back(text.substr(start,ende-start));
                }
                start = ende+1;
            }

            return splittext;
        }

        static vector<string>* split(string text,string trennzeichen)
        {
            vector<int>* pos = findeZeichenpositionen(text,trennzeichen);

            vector<string>* splittext = new vector<string>();

            int start = 0;
            int ende  = 0;
            for(int i=0;i<(pos->size())+1;i++)
            {
                if(i<pos->size())
                    ende = pos->at(i);
                else
                    ende = text.size();

                if( start < ende  )
                {
                     splittext->push_back(text.substr(start,ende-start));
                }
                start = ende+1;
            }

            return splittext;
        }

        static string ersetze(string text,string alt, string neu)
        {
            char zeichen[2] = {' ','\0'};

            string erg = "";
            for(int i=0;i<text.size();i++)
            {
                if(i<text.size()-alt.length() && text.substr(i,alt.size()) == alt )
                {
                    erg.append(neu);
                    i+=alt.size()-1;
                }
                else if(i<text.size())
                {
                    zeichen[0] = text.at(i);
                    erg.append(zeichen);
                }
            }
            return erg;
        }

        static string lueckentext(string intext, string p0="",string p1="",string p2="", string p3="", string p4="",
                                        string p5="",string p6="",string p7="", string p8="", string p9="")
        {
            string text = intext;

            text = ersetze(text,"%0",p0);              
            text = ersetze(text,"%1",p1);              
            text = ersetze(text,"%2",p2);              
            text = ersetze(text,"%3",p3);              
            text = ersetze(text,"%4",p4);              
            text = ersetze(text,"%5",p5);              
            text = ersetze(text,"%6",p6);              
            text = ersetze(text,"%7",p7);              
            text = ersetze(text,"%8",p8);              
            text = ersetze(text,"%9",p9); 

            return text;             
        }

};

