    void setzePinAlsEingang(int pin)
	{
	    switch(pin)
		{
		    case 1:
			    DDRB &= 0b11111110;
			break;
		    case 2:
			    DDRB &= 0b11111101;
			break;
		    case 3:
			    DDRB &= 0b11111011;
			break;
		    case 4:
			    DDRB &= 0b11110111;
			break;
		    case 5:
			    DDRB &= 0b11101111;
			break;
		    case 6:
			    DDRB &= 0b11011111;
			break;
		    case 7:
			    DDRB &= 0b10111111;
			break;
		    case 8:
			    DDRB &= 0b01111111;
			break;

		    case 14:
			    DDRD &= 0b11111110;
			break;
		    case 15:
			    DDRD &= 0b11111101;
			break;
		    case 16:
			    DDRD &= 0b11111011;
			break;
		    case 17:
			    DDRD &= 0b11110111;
			break;
		    case 18:
			    DDRD &= 0b11101111;
			break;
		    case 19:
			    DDRD &= 0b11011111;
			break;
		    case 20:
			    DDRD &= 0b10111111;
			break;
		    case 21:
			    DDRD &= 0b01111111;
			break;


		    case 22:
			    DDRC &= 0b11111110;
			break;
		    case 23:
			    DDRC &= 0b11111101;
			break;
		    case 24:
			    DDRC &= 0b11111011;
			break;
		    case 25:
			    DDRC &= 0b11110111;
			break;
		    case 26:
			    DDRC &= 0b11101111;
			break;
		    case 27:
			    DDRC &= 0b11011111;
			break;
		    case 28:
			    DDRC &= 0b10111111;
			break;
		    case 29:
			    DDRC &= 0b01111111;
			break;

		    case 33:
			    DDRA &= 0b01111111;
			break;
		    case 34:
			    DDRA &= 0b10111111;
			break;
		    case 35:
			    DDRA &= 0b11011111;
			break;
		    case 36:
			    DDRA &= 0b11101111;
			break;
		    case 37:
			    DDRA &= 0b11110111;
			break;
		    case 38:
			    DDRA &= 0b11111011;
			break;
		    case 39:
			    DDRA &= 0b11111101;
			break;
		    case 40:
			    DDRA &= 0b11111110;
			break;

			default:
			break;
		}
		return;
	}

    static void setzePinAlsAusgang(int pin)
	{
	    switch(pin)
		{
		    case 1:
			    DDRB |= 0b00000001;
			break;
		    case 2:
			    DDRB |= 0b00000010;
			break;
		    case 3:
			    DDRB |= 0b00000100;
			break;
		    case 4:
			    DDRB |= 0b00001000;
			break;
		    case 5:
			    DDRB |= 0b00010000;
			break;
		    case 6:
			    DDRB |= 0b00100000;
			break;
		    case 7:
			    DDRB |= 0b01000000;
			break;
		    case 8:
			    DDRB |= 0b10000000;
			break;

		    case 14:
			    DDRD |= 0b00000001;
			break;
		    case 15:
			    DDRD |= 0b00000010;
			break;
		    case 16:
			    DDRD |= 0b00000100;
			break;
		    case 17:
			    DDRD |= 0b00001000;
			break;
		    case 18:
			    DDRD |= 0b00010000;
			break;
		    case 19:
			    DDRD |= 0b00100000;
			break;
		    case 20:
			    DDRD |= 0b01000000;
			break;
		    case 21:
			    DDRD |= 0b10000000;
			break;


		    case 22:
			    DDRC |= 0b00000001;
			break;
		    case 23:
			    DDRC |= 0b00000010;
			break;
		    case 24:
			    DDRC |= 0b00000100;
			break;
		    case 25:
			    DDRC |= 0b00001000;
			break;
		    case 26:
			    DDRC |= 0b00010000;
			break;
		    case 27:
			    DDRC |= 0b00100000;
			break;
		    case 28:
			    DDRC |= 0b01000000;
			break;
		    case 29:
			    DDRC |= 0b10000000;
			break;

		    case 33:
			    DDRA |= 0b10000000;
			break;
		    case 34:
			    DDRA |= 0b01000000;
			break;
		    case 35:
			    DDRA |= 0b00100000;
			break;
		    case 36:
			    DDRA |= 0b00010000;
			break;
		    case 37:
			    DDRA |= 0b00001000;
			break;
		    case 38:
			    DDRA |= 0b00000100;
			break;
		    case 39:
			    DDRA |= 0b00000010;
			break;
		    case 40:
			    DDRA |= 0b00000001;
			break;

			default:
			break;
		}
		return;
	}


    void setzePinHigh(int pin)
	{
	    switch(pin)
		{
		    case 1:
			    PORTB |=  0b00000001;
			break;
		    case 2:
			    PORTB |=  0b00000010;
			break;
		    case 3:
			    PORTB |=  0b00000100;
			break;
		    case 4:
			    PORTB |=  0b00001000;
			break;
		    case 5:
			    PORTB |=  0b00010000;
			break;
		    case 6:
			    PORTB |=  0b00100000;
			break;
		    case 7:
			    PORTB |=  0b01000000;
			break;
		    case 8:
			    PORTB |=  0b10000000;
			break;

		    case 14:
			    PORTD |=  0b00000001;
			break;
		    case 15:
			    PORTD |=  0b00000010;
			break;
		    case 16:
			    PORTD |=  0b00000100;
			break;
		    case 17:
			    PORTD |=  0b00001000;
			break;
		    case 18:
			    PORTD |=  0b00010000;
			break;
		    case 19:
			    PORTD |=  0b00100000;
			break;
		    case 20:
			    PORTD |=  0b01000000;
			break;
		    case 21:
			    PORTD |=  0b10000000;
			break;


		    case 22:
			    PORTC |=  0b00000001;
			break;
		    case 23:
			    PORTC |=  0b00000010;
			break;
		    case 24:
			    PORTC |=  0b00000100;
			break;
		    case 25:
			    PORTC |=  0b00001000;
			break;
		    case 26:
			    PORTC |=  0b00010000;
			break;
		    case 27:
			    PORTC |=  0b00100000;
			break;
		    case 28:
			    PORTC |=  0b01000000;
			break;
		    case 29:
			    PORTC |=  0b10000000;
			break;

		    case 33:
			    PORTA |=  0b10000000;
			break;
		    case 34:
			    PORTA |=  0b01000000;
			break;
		    case 35:
			    PORTA |=  0b00100000;
			break;
		    case 36:
			    PORTA |=  0b00010000;
			break;
		    case 37:
			    PORTA |=  0b00001000;
			break;
		    case 38:
			    PORTA |=  0b00000100;
			break;
		    case 39:
			    PORTA |=  0b00000010;
			break;
		    case 40:
			    PORTA |=  0b00000001;
			break;

			default:
			break;
		}
		return;
	}

    void setzePinLow(int pin)
	{
	    switch(pin)
		{
		    case 1:
			    PORTB &=   0b11111110;
			break;
		    case 2:
			    PORTB &=   0b11111101;
			break;
		    case 3:
			    PORTB &=   0b11111011;
			break;
		    case 4:
			    PORTB &=   0b11110111;
			break;
		    case 5:
			    PORTB &=   0b11101111;
			break;
		    case 6:
			    PORTB &=   0b11011111;
			break;
		    case 7:
			    PORTB &=   0b10111111;
			break;
		    case 8:
			    PORTB &=   0b01111111;
			break;

		    case 14:
			    PORTD &=   0b11111110;
			break;
		    case 15:
			    PORTD &=   0b11111101;
			break;
		    case 16:
			    PORTD &=   0b11111011;
			break;
		    case 17:
			    PORTD &=   0b11110111;
			break;
		    case 18:
			    PORTD &=   0b11101111;
			break;
		    case 19:
			    PORTD &=   0b11011111;
			break;
		    case 20:
			    PORTD &=   0b10111111;
			break;
		    case 21:
			    PORTD &=   0b01111111;
			break;


		    case 22:
			    PORTC &=   0b11111110;
			break;
		    case 23:
			    PORTC &=   0b11111101;
			break;
		    case 24:
			    PORTC &=   0b11111011;
			break;
		    case 25:
			    PORTC &=   0b11110111;
			break;
		    case 26:
			    PORTC &=   0b11101111;
			break;
		    case 27:
			    PORTC &=   0b11011111;
			break;
		    case 28:
			    PORTC &=   0b10111111;
			break;
		    case 29:
			    PORTC &=   0b01111111;
			break;

		    case 33:
			    PORTA &=   0b01111111;
			break;
		    case 34:
			    PORTA &=   0b10111111;
			break;
		    case 35:
			    PORTA &=   0b11011111;
			break;
		    case 36:
			    PORTA &=   0b11101111;
			break;
		    case 37:
			    PORTA &=   0b11110111;
			break;
		    case 38:
			    PORTA &=   0b11111011;
			break;
		    case 39:
			    PORTA &=   0b11111101;
			break;
		    case 40:
			    PORTA &=   0b11111110;
			break;

			default:
			break;
		}
		return;
	}



    bool liesPin(int pin)
	{
	    switch(pin)
		{
		    case 1:
			    if(  (PINB & 0b00000001) > 0  ) return true;
			break;
		    case 2:
			    if(  (PINB & 0b00000010) > 0  ) return true;
			break;
		    case 3:
			    if(  (PINB & 0b00000100) > 0  ) return true;
			break;
		    case 4:
			    if(  (PINB & 0b00001000) > 0  ) return true;
			break;
		    case 5:
			    if(  (PINB & 0b00010000) > 0  ) return true;
			break;
		    case 6:
			    if(  (PINB & 0b00100000) > 0  ) return true;
			break;
		    case 7:
			    if(  (PINB & 0b01000000) > 0  ) return true;
			break;
		    case 8:
			    if(  (PINB & 0b10000000) > 0  ) return true;
			break;

		    case 14:
			    if(  (PIND & 0b00000001) > 0  ) return true;
			break;
		    case 15:
			    if(  (PIND & 0b00000010) > 0  ) return true;
			break;
		    case 16:
			    if(  (PIND & 0b00000100) > 0  ) return true;
			break;
		    case 17:
			    if(  (PIND & 0b00001000) > 0  ) return true;
			break;
		    case 18:
			    if(  (PIND & 0b00010000) > 0  ) return true;
			break;
		    case 19:
			    if(  (PIND & 0b00100000) > 0  ) return true;
			break;
		    case 20:
			    if(  (PIND & 0b01000000) > 0  ) return true;
			break;
		    case 21:
			    if(  (PIND & 0b10000000) > 0  ) return true;
			break;


		    case 22:
			    if(  (PINC & 0b00000001) > 0  ) return true;
			break;
		    case 23:
			    if(  (PINC & 0b00000010) > 0  ) return true;
			break;
		    case 24:
			    if(  (PINC & 0b00000100) > 0  ) return true;
			break;
		    case 25:
			    if(  (PINC & 0b00001000) > 0  ) return true;
			break;
		    case 26:
			    if(  (PINC & 0b00010000) > 0  ) return true;
			break;
		    case 27:
			    if(  (PINC & 0b00100000) > 0  ) return true;
			break;
		    case 28:
			    if(  (PINC & 0b01000000) > 0  ) return true;
			break;
		    case 29:
			    if(  (PINC & 0b10000000) > 0  ) return true;
			break;

		    case 33:
			    if(  (PINA & 0b10000000) > 0  ) return true;
			break;
		    case 34:
			    if(  (PINA & 0b01000000) > 0  ) return true;
			break;
		    case 35:
			    if(  (PINA & 0b00100000) > 0  ) return true;
			break;
		    case 36:
			    if(  (PINA & 0b00010000) > 0  ) return true;
			break;
		    case 37:
			    if(  (PINA & 0b00001000) > 0  ) return true;
			break;
		    case 38:
			    if(  (PINA & 0b00000100) > 0  ) return true;
			break;
		    case 39:
			    if(  (PINA & 0b00000010) > 0  ) return true;
			break;
		    case 40:
			    if(  (PINA & 0b00000001) > 0  ) return true;
			break;

			default:
				return false;
			break;
		}
		return false;
	}


