class PWMtimer2
{
    public: 
        PWMtimer2(RS232* rs232)
	    {
		    rs232->sendeText("\n\rInstanz der Klasse *PWMtimer2* gebildet\n\r");
		    rs232->sendeText("\n\r***** PWM Timer 2 *****\n\r");
		    rs232->sendeText("AVR-Konfiguration fuer ATmega32:\n\r");
		    rs232->sendeText("Betroffene Pins: 21 (PD7/OC2)\n\r");
		    rs232->sendeText("Betroffene Register: TCCR2\n\r");
		    rs232->sendeText("Bezeichnung: Timer2 auf 8 Bit Phase Correct PWM-Mode mit Taktteilung 1\n\r");
		    rs232->sendeText("Methoden:\n\r");
		    rs232->sendeText("start(): Initialisieren\n\r");
		    rs232->sendeText("stop():  Zurcksetzen\n\r");
		    rs232->sendeText("setzePulsbreitePin21(unsigned char) \n\r");
	    }

		PWMtimer2()
		{
		}

        void stop()  //alle Register zurcksetzen, Timer und PWM ausschalten.
		{
		    OCR2 = 0;
            TCCR2 = (0<<FOC2) | (0<<WGM20) | (0<<COM21) | (0<<COM20) | (0<<WGM21) | (0<<CS22) | (0<<CS21) | (0<<CS20);

            PORTD &= 255 - (1<<PD7); //sicherheitshalber auf low setzen (L293 reagiert auf high !)
		}

		void setzePulsbreitePin21(unsigned char breite)
		{
		    OCR2 = breite;
		}


        void start()
		{
            TCCR2 = (0<<FOC2) | (1<<WGM20) | (1<<COM21) | (0<<COM20) | (0<<WGM21) | (0<<CS22) | (0<<CS21) | (1<<CS20);
            DDRD |= (1<<PD7); //auf Ausgang setzen.
		    OCR2 = 0;
		}
};
